#
# This script was written by Michel Arboi <arboi@alussinan.org>
#
# GNU Public Licence
#
########################

if(description)
{
 script_id(11238);
 script_version ("$Revision: 1.2 $");
 
 name["english"] = "Anti Nessus defenses";
 name["francais"] = "Dfenses anti Nessus";
 script_name(english:name["english"], francais:name["francais"]);
 
 desc["english"] = "
It seems that your web server rejects requests 
from Nessus. It is probably protected by a reverse proxy.

Risk factor : None

Solution : change your configuration 
           if your tests to be accurate";

 desc["francais"] = "
Il semble que votre serveur web rejette les requtes
envoyes par Nessus. Il est probablement protg par un 
relais. 


Facteur de risque : Aucun

Solution : Modifiez votre configuration 
           si vous voulez des tests exhaustifs";


 script_description(english:desc["english"], francais:desc["francais"]);
 
 summary["english"] = "Detects anti Nessus features";
 summary["francais"] = "Dtecte des fonctions anti Nessus";
 script_summary(english:summary["english"], francais:summary["francais"]);
 
 script_category(ACT_GATHER_INFO); 
 
 script_copyright(english:"This script is Copyright (C) 2003 Michel Arboi",
		francais:"Ce script est Copyright (C) 2003 Michel Arboi");
 family["english"] = "CGI abuses";
 family["francais"] = "Abus de CGI";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencie("find_service.nes");
 script_require_ports("Services/www", "httpver.nasl", 80);
 exit(0);
}

#

include("http_func.inc");
include("http_keepalive.inc");
include("misc_func.inc");

port = get_kb_item("Services/www");
if(!port)port = 80;
if (! get_port_state(port)) exit(0);



u = string("/NessusTest", rand(), ".html");
r = http_get(port: port, item: u);

c1 = http_keepalive_send_recv(port:port, data:r);
if( c1 == NULL ) exit(0);
c1 = egrep(pattern:"^HTTP/[0-9]\.[0-9] [0-9]* .*", string:c1);


u = string("/", rand_str(), ".html");
r = http_get(port: port, item: u);

c2 = http_keepalive_send_recv(port:port, data:r);
if(c2 == NULL)exit(0);
c2 = egrep(pattern:"^HTTP/[0-9]\.[0-9] [0-9]* .*", string:c2);



if (c1 != c2)
{
  security_warning(port);
  set_kb_item(name: string("www/anti-nessus/",port,"/rand-url"), value: TRUE);
  exit(0);
}


r = http_get(port: port, item: "/");
c1 = http_keepalive_send_recv(port:port, data:r);
if(c1 == NULL)exit(0);
c1 = egrep(pattern:"^HTTP/[0-9]\.[0-9] [0-9]* .*", string:c1);


ua = string("\nUser-Agent: ", 
	rand_str(charset: "AmayaLynxMozilla", length: 6), "/",
	rand() % 10, ".", rand() % 10, "\r\n");
	
r2 = ereg_replace(string: r, pattern: '\nUser-Agent:[^\r]*Nessus[^\r]*\r\n', replace: ua);
if (r == r2) exit(0);	# Cannot test

c2 = http_keepalive_send_recv(port:port, data:r2);
if(c2 == NULL)exit(0);
c2 = egrep(pattern:"^HTTP/[0-9]\.[0-9] [0-9]* .*", string:c2);


if (c1 != c2)
{
  security_warning(port);
  set_kb_item(name: string("www/anti-nessus/",port,"/user-agent"),value: ua);
  exit(0);
}

