#
#
# ping code taken from mssql_ping by H D Moore
# 
#
if(description)
{
 script_id(11216);
 script_cve_id("CVE-2002-0649", "CVE-2002-0650", "CAN-2002-1145");
 script_version ("$Revision: 1.3 $");
 name["english"] = "SQL 'Sapphire' worm";
 script_name(english:name["english"]);
 
 desc["english"] = "
The remote host *might* be infected by the 'Sapphire' SQL
worm. 

Nessus could determine this, because the remote host has
TCP port 1433 open but UDP 1434 does not reply as it should.

If you are blocking UDP traffic to port 1434, then we recommand you 
also block TCP traffic to port 1433, but you can ignore this alert.

If the remote host is actually compromised :

	- Stop MS SQL server
	- Install the patch described in MS advisory MS02-061
	- Restart your SQL server
	

See also :
- http://www.eeye.com/html/Research/Flash/AL20030125.html
- http://www.cisco.com/warp/public/707/cisco-sn-20030125-worm.shtml
- http://www.iss.net/security_center/static/10031.php
- http://www.nextgenss.com/advisories/mssql-udp.txt
- http://www.cert.org/advisories/CA-2003-04.html
- http://www.techie.hopto.org/sqlworm.html
- http://www.boredom.org/~cstone/worm-annotated.txt

Solution : See MS Advisory MS02-061
Risk factor : High";


 script_description(english:desc["english"]);
 
 summary["english"] = "Detects if the Sapphire worm compromised the remote host";
 script_summary(english:summary["english"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2003 Renaud Deraison");
 family["english"] = "Windows";
 script_family(english:family["english"]);
 exit(0);
}

#
# The script code starts here
#


function sql_ping()
{
 req = raw_string(0x02);
 if(!get_udp_port_state(1434))return(0);
 soc = open_sock_udp(1434);


 if(soc)
 {
	send(socket:soc, data:req);
	r  = recv(socket:soc, length:4096);
	close(soc);
	return(r);
 }
}


if(get_port_state(1433))
{
 soc = open_sock_tcp(1433);
 if(soc)
 {
  r = sql_ping();
  if(!r)security_hole(port:1434, proto:"udp");
 }
}





